# Windows Proxy Changer

Простая программка для переключения между прокси в Windows. ***Разработана прежде всего для личных нужд.***

## Запуск

Для запуска программы предоставлены .bat и .cmd файлы на которые можно сделать ярлыки и пользоваться с удобством.
В этих файлах программа запускается с помощью коммандной строки. В целом есть 2 способа запуска программы:

- без аргументов, например:
```
javaw -jar proxy.jar
```
- с аргументами, где в качестве аргумента принимается адрес автоматического сценария прокси:
```
javaw -jar proxy.jar "http://proxy.mcs.br:8080/array.dll?Get.Routing.Script"
```

После запуска программа появляется в трее: 

![Программа в трее](./readmeSrc/tray.png)

## Использование

При нажатии на значок ПКМ появится меню:

![Меню](./readmeSrc/trayMenu.png)


В меню мы соответственно можем:
- Добавить новый прокси
- Переключить прокси
- Удалить прокси
- Остановить прокси
- Выйти

## Функции

### 1. Add proxy...

При нажатии на этот пункт меню мы увидим следующее окошко:

![Добавление прокси](./readmeSrc/addProxy.png)

Соответственно вставляем адрес сценария и нажимаем **Add**. Адреса сценариев сохраняются в конфиг.

### 2. Proxy

При наведении на этот пункт меню мы увидим выпадающий список уже добавленных прокси:

![Список прокси](./readmeSrc/proxyList.png)

Мы можем по нажатию на нужный адрес прокси переключаться между ними.
Программа будет с заданным периодом прописывать в реестр выбранный адрес сценария. Период задается в конфиге.

### 3. Delete proxy...

При нажатии на этот пункт меню мы увидим следующее окошко:

![Добавление прокси](./readmeSrc/deleteProxy.png)

Соответственно отмечаем чекбоксы нужных прокси и нажимаем **Delete**.

### 4. Stop

При нажатии на этот пункт меню периодическое прописывание адреса сценария в реестр приостанавливается. Возобновить можно выбрав нужный адрес в пункте Proxy.

### 5. Exit

Закрывает программу.

## config.json

Для сохранения параметров программа использует файл config.json из директории config. В нем содержатся следующие параметры:
- port - какой порт займет программа. Бинд порта сделан для предотвращения запуска 2х экземпляров программы.
- proxyList - список адресов сценариев прокси. Собсна используется чтобы после выхода из программы все прокси сохранились.
- setRepeatTimeMs - колличество миллисекунд через которое прокси будет прописываться в реестр. Например для запуска раз в минуту пишем 60000.
- deleteBySevenDays - принимает значения true или false. Если стоит true, будет чистить логи старше 7 дней.

## Программная лабуда

Программа использует jdk-17, которая должная быть установлена на компьютере. Так же использует библеотеки: 
- json-simple-1.1.1 (для работы с конфигом)
- dhaverdLogs (для записи логов работы)

Программу лучше качать архивом, т.к. там лежат файлы нужные для работы программы.
